﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Net.Mail;
using System.Net.Mime;
using System.Text;
using DataDynamics.Reports;
using DataDynamics.Reports.Extensibility.Rendering;
using DataDynamics.Reports.Extensibility.Rendering.IO;
using DataDynamics.Reports.Rendering.Word;
using DDRonWeb;

namespace SendEmail
{
    class Program
    {
        static void Main(string[] args)
        {
            SmtpClient smtp = new SmtpClient("localhost", 25);
            MailAddress from = new MailAddress("admin@sergeya-hq.com");
            MailAddress to = new MailAddress("s.abakumoff@gmail.com");
            MailMessage message = new MailMessage(from, to);
            message.Subject = "mht content 8";
            message.IsBodyHtml = true;

            ReportDefinition def = new ReportDefinition(new FileInfo(@"..\..\Products.rdlx"));
            ReportRuntime runtime = new ReportRuntime(def);
            WordRenderingExtension renderer = new WordRenderingExtension();
            NameValueCollection settings = (renderer as IConfigurable).GetSupportedSettings().GetSettings();
            MemoryStreamProvider provider = new MemoryStreamProvider();
            runtime.Render(renderer, provider, settings);
            MemoryStreamProvider.MemoryStreamInfo memoryStreamInfo = provider.GetPrimaryStream() as MemoryStreamProvider.MemoryStreamInfo;
            AlternateView htmlMessage = null;
            if (memoryStreamInfo != null)
            {
                MemoryStream memoryStream = memoryStreamInfo.OpenStream() as MemoryStream;
                byte[] data = memoryStream.ToArray();
                htmlMessage = AlternateView.CreateAlternateViewFromString(
                    Encoding.UTF8.GetString(data), new ContentType(MediaTypeNames.Text.Html));
            }
            StreamInfo[] secondaryStreams = provider.GetSecondaryStreams();
            foreach(StreamInfo secStream in secondaryStreams)
            {
                if(secStream != null)
                {
                    MemoryStream memoryStream = secStream.OpenStream() as MemoryStream;
                    byte[] data = memoryStream.ToArray();
                    MemoryStream resourceStream = new MemoryStream();
                    resourceStream.Write(data,0,data.Length);
                    resourceStream.Position = 0;
                    LinkedResource linkedRes = new LinkedResource(resourceStream, MediaTypeNames.Image.Gif);
                    linkedRes.ContentId = secStream.Uri.LocalPath;
                    linkedRes.TransferEncoding = TransferEncoding.Base64;
                    htmlMessage.LinkedResources.Add(linkedRes);
                }
            }
            message.AlternateViews.Add(htmlMessage);
            message.SubjectEncoding = System.Text.Encoding.UTF8;
            smtp.Send(message);
            message.Dispose();
        }
    }
}
